<?php

namespace Eater\Glim\Model\Base;

use \Exception;
use \PDO;
use Eater\Glim\Model\EmailAddress as ChildEmailAddress;
use Eater\Glim\Model\EmailAddressQuery as ChildEmailAddressQuery;
use Eater\Glim\Model\Map\EmailAddressTableMap;
use Propel\Runtime\Propel;
use Propel\Runtime\ActiveQuery\Criteria;
use Propel\Runtime\ActiveQuery\ModelCriteria;
use Propel\Runtime\ActiveQuery\ModelJoin;
use Propel\Runtime\Collection\ObjectCollection;
use Propel\Runtime\Connection\ConnectionInterface;
use Propel\Runtime\Exception\PropelException;

/**
 * Base class that represents a query for the 'email_address' table.
 *
 *
 *
 * @method     ChildEmailAddressQuery orderById($order = Criteria::ASC) Order by the id column
 * @method     ChildEmailAddressQuery orderByVerified($order = Criteria::ASC) Order by the verified column
 * @method     ChildEmailAddressQuery orderByVerification($order = Criteria::ASC) Order by the verification column
 * @method     ChildEmailAddressQuery orderByAddress($order = Criteria::ASC) Order by the address column
 * @method     ChildEmailAddressQuery orderByOwner($order = Criteria::ASC) Order by the owner column
 *
 * @method     ChildEmailAddressQuery groupById() Group by the id column
 * @method     ChildEmailAddressQuery groupByVerified() Group by the verified column
 * @method     ChildEmailAddressQuery groupByVerification() Group by the verification column
 * @method     ChildEmailAddressQuery groupByAddress() Group by the address column
 * @method     ChildEmailAddressQuery groupByOwner() Group by the owner column
 *
 * @method     ChildEmailAddressQuery leftJoin($relation) Adds a LEFT JOIN clause to the query
 * @method     ChildEmailAddressQuery rightJoin($relation) Adds a RIGHT JOIN clause to the query
 * @method     ChildEmailAddressQuery innerJoin($relation) Adds a INNER JOIN clause to the query
 *
 * @method     ChildEmailAddressQuery leftJoinUserRelatedByOwner($relationAlias = null) Adds a LEFT JOIN clause to the query using the UserRelatedByOwner relation
 * @method     ChildEmailAddressQuery rightJoinUserRelatedByOwner($relationAlias = null) Adds a RIGHT JOIN clause to the query using the UserRelatedByOwner relation
 * @method     ChildEmailAddressQuery innerJoinUserRelatedByOwner($relationAlias = null) Adds a INNER JOIN clause to the query using the UserRelatedByOwner relation
 *
 * @method     ChildEmailAddressQuery leftJoinUserRelatedByEmail($relationAlias = null) Adds a LEFT JOIN clause to the query using the UserRelatedByEmail relation
 * @method     ChildEmailAddressQuery rightJoinUserRelatedByEmail($relationAlias = null) Adds a RIGHT JOIN clause to the query using the UserRelatedByEmail relation
 * @method     ChildEmailAddressQuery innerJoinUserRelatedByEmail($relationAlias = null) Adds a INNER JOIN clause to the query using the UserRelatedByEmail relation
 *
 * @method     ChildEmailAddressQuery leftJoinEmailMessageRelatedByRecipient($relationAlias = null) Adds a LEFT JOIN clause to the query using the EmailMessageRelatedByRecipient relation
 * @method     ChildEmailAddressQuery rightJoinEmailMessageRelatedByRecipient($relationAlias = null) Adds a RIGHT JOIN clause to the query using the EmailMessageRelatedByRecipient relation
 * @method     ChildEmailAddressQuery innerJoinEmailMessageRelatedByRecipient($relationAlias = null) Adds a INNER JOIN clause to the query using the EmailMessageRelatedByRecipient relation
 *
 * @method     ChildEmailAddressQuery leftJoinEmailMessageRelatedBySender($relationAlias = null) Adds a LEFT JOIN clause to the query using the EmailMessageRelatedBySender relation
 * @method     ChildEmailAddressQuery rightJoinEmailMessageRelatedBySender($relationAlias = null) Adds a RIGHT JOIN clause to the query using the EmailMessageRelatedBySender relation
 * @method     ChildEmailAddressQuery innerJoinEmailMessageRelatedBySender($relationAlias = null) Adds a INNER JOIN clause to the query using the EmailMessageRelatedBySender relation
 *
 * @method     \Eater\Glim\Model\UserQuery|\Eater\Glim\Model\EmailMessageQuery endUse() Finalizes a secondary criteria and merges it with its primary Criteria
 *
 * @method     ChildEmailAddress findOne(ConnectionInterface $con = null) Return the first ChildEmailAddress matching the query
 * @method     ChildEmailAddress findOneOrCreate(ConnectionInterface $con = null) Return the first ChildEmailAddress matching the query, or a new ChildEmailAddress object populated from the query conditions when no match is found
 *
 * @method     ChildEmailAddress findOneById(int $id) Return the first ChildEmailAddress filtered by the id column
 * @method     ChildEmailAddress findOneByVerified(boolean $verified) Return the first ChildEmailAddress filtered by the verified column
 * @method     ChildEmailAddress findOneByVerification(string $verification) Return the first ChildEmailAddress filtered by the verification column
 * @method     ChildEmailAddress findOneByAddress(string $address) Return the first ChildEmailAddress filtered by the address column
 * @method     ChildEmailAddress findOneByOwner(int $owner) Return the first ChildEmailAddress filtered by the owner column *

 * @method     ChildEmailAddress requirePk($key, ConnectionInterface $con = null) Return the ChildEmailAddress by primary key and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildEmailAddress requireOne(ConnectionInterface $con = null) Return the first ChildEmailAddress matching the query and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 *
 * @method     ChildEmailAddress requireOneById(int $id) Return the first ChildEmailAddress filtered by the id column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildEmailAddress requireOneByVerified(boolean $verified) Return the first ChildEmailAddress filtered by the verified column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildEmailAddress requireOneByVerification(string $verification) Return the first ChildEmailAddress filtered by the verification column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildEmailAddress requireOneByAddress(string $address) Return the first ChildEmailAddress filtered by the address column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildEmailAddress requireOneByOwner(int $owner) Return the first ChildEmailAddress filtered by the owner column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 *
 * @method     ChildEmailAddress[]|ObjectCollection find(ConnectionInterface $con = null) Return ChildEmailAddress objects based on current ModelCriteria
 * @method     ChildEmailAddress[]|ObjectCollection findById(int $id) Return ChildEmailAddress objects filtered by the id column
 * @method     ChildEmailAddress[]|ObjectCollection findByVerified(boolean $verified) Return ChildEmailAddress objects filtered by the verified column
 * @method     ChildEmailAddress[]|ObjectCollection findByVerification(string $verification) Return ChildEmailAddress objects filtered by the verification column
 * @method     ChildEmailAddress[]|ObjectCollection findByAddress(string $address) Return ChildEmailAddress objects filtered by the address column
 * @method     ChildEmailAddress[]|ObjectCollection findByOwner(int $owner) Return ChildEmailAddress objects filtered by the owner column
 * @method     ChildEmailAddress[]|\Propel\Runtime\Util\PropelModelPager paginate($page = 1, $maxPerPage = 10, ConnectionInterface $con = null) Issue a SELECT query based on the current ModelCriteria and uses a page and a maximum number of results per page to compute an offset and a limit
 *
 */
abstract class EmailAddressQuery extends ModelCriteria
{
    protected $entityNotFoundExceptionClass = '\\Propel\\Runtime\\Exception\\EntityNotFoundException';

    /**
     * Initializes internal state of \Eater\Glim\Model\Base\EmailAddressQuery object.
     *
     * @param     string $dbName The database name
     * @param     string $modelName The phpName of a model, e.g. 'Book'
     * @param     string $modelAlias The alias for the model in this query, e.g. 'b'
     */
    public function __construct($dbName = 'default', $modelName = '\\Eater\\Glim\\Model\\EmailAddress', $modelAlias = null)
    {
        parent::__construct($dbName, $modelName, $modelAlias);
    }

    /**
     * Returns a new ChildEmailAddressQuery object.
     *
     * @param     string $modelAlias The alias of a model in the query
     * @param     Criteria $criteria Optional Criteria to build the query from
     *
     * @return ChildEmailAddressQuery
     */
    public static function create($modelAlias = null, Criteria $criteria = null)
    {
        if ($criteria instanceof ChildEmailAddressQuery) {
            return $criteria;
        }
        $query = new ChildEmailAddressQuery();
        if (null !== $modelAlias) {
            $query->setModelAlias($modelAlias);
        }
        if ($criteria instanceof Criteria) {
            $query->mergeWith($criteria);
        }

        return $query;
    }

    /**
     * Find object by primary key.
     * Propel uses the instance pool to skip the database if the object exists.
     * Go fast if the query is untouched.
     *
     * <code>
     * $obj  = $c->findPk(12, $con);
     * </code>
     *
     * @param mixed $key Primary key to use for the query
     * @param ConnectionInterface $con an optional connection object
     *
     * @return ChildEmailAddress|array|mixed the result, formatted by the current formatter
     */
    public function findPk($key, ConnectionInterface $con = null)
    {
        if ($key === null) {
            return null;
        }
        if ((null !== ($obj = EmailAddressTableMap::getInstanceFromPool((string) $key))) && !$this->formatter) {
            // the object is already in the instance pool
            return $obj;
        }
        if ($con === null) {
            $con = Propel::getServiceContainer()->getReadConnection(EmailAddressTableMap::DATABASE_NAME);
        }
        $this->basePreSelect($con);
        if ($this->formatter || $this->modelAlias || $this->with || $this->select
         || $this->selectColumns || $this->asColumns || $this->selectModifiers
         || $this->map || $this->having || $this->joins) {
            return $this->findPkComplex($key, $con);
        } else {
            return $this->findPkSimple($key, $con);
        }
    }

    /**
     * Find object by primary key using raw SQL to go fast.
     * Bypass doSelect() and the object formatter by using generated code.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     ConnectionInterface $con A connection object
     *
     * @throws \Propel\Runtime\Exception\PropelException
     *
     * @return ChildEmailAddress A model object, or null if the key is not found
     */
    protected function findPkSimple($key, ConnectionInterface $con)
    {
        $sql = 'SELECT id, verified, verification, address, owner FROM email_address WHERE id = :p0';
        try {
            $stmt = $con->prepare($sql);
            $stmt->bindValue(':p0', $key, PDO::PARAM_INT);
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute SELECT statement [%s]', $sql), 0, $e);
        }
        $obj = null;
        if ($row = $stmt->fetch(\PDO::FETCH_NUM)) {
            /** @var ChildEmailAddress $obj */
            $obj = new ChildEmailAddress();
            $obj->hydrate($row);
            EmailAddressTableMap::addInstanceToPool($obj, (string) $key);
        }
        $stmt->closeCursor();

        return $obj;
    }

    /**
     * Find object by primary key.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     ConnectionInterface $con A connection object
     *
     * @return ChildEmailAddress|array|mixed the result, formatted by the current formatter
     */
    protected function findPkComplex($key, ConnectionInterface $con)
    {
        // As the query uses a PK condition, no limit(1) is necessary.
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $dataFetcher = $criteria
            ->filterByPrimaryKey($key)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->formatOne($dataFetcher);
    }

    /**
     * Find objects by primary key
     * <code>
     * $objs = $c->findPks(array(12, 56, 832), $con);
     * </code>
     * @param     array $keys Primary keys to use for the query
     * @param     ConnectionInterface $con an optional connection object
     *
     * @return ObjectCollection|array|mixed the list of results, formatted by the current formatter
     */
    public function findPks($keys, ConnectionInterface $con = null)
    {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getReadConnection($this->getDbName());
        }
        $this->basePreSelect($con);
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $dataFetcher = $criteria
            ->filterByPrimaryKeys($keys)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->format($dataFetcher);
    }

    /**
     * Filter the query by primary key
     *
     * @param     mixed $key Primary key to use for the query
     *
     * @return $this|ChildEmailAddressQuery The current query, for fluid interface
     */
    public function filterByPrimaryKey($key)
    {

        return $this->addUsingAlias(EmailAddressTableMap::COL_ID, $key, Criteria::EQUAL);
    }

    /**
     * Filter the query by a list of primary keys
     *
     * @param     array $keys The list of primary key to use for the query
     *
     * @return $this|ChildEmailAddressQuery The current query, for fluid interface
     */
    public function filterByPrimaryKeys($keys)
    {

        return $this->addUsingAlias(EmailAddressTableMap::COL_ID, $keys, Criteria::IN);
    }

    /**
     * Filter the query on the id column
     *
     * Example usage:
     * <code>
     * $query->filterById(1234); // WHERE id = 1234
     * $query->filterById(array(12, 34)); // WHERE id IN (12, 34)
     * $query->filterById(array('min' => 12)); // WHERE id > 12
     * </code>
     *
     * @param     mixed $id The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildEmailAddressQuery The current query, for fluid interface
     */
    public function filterById($id = null, $comparison = null)
    {
        if (is_array($id)) {
            $useMinMax = false;
            if (isset($id['min'])) {
                $this->addUsingAlias(EmailAddressTableMap::COL_ID, $id['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($id['max'])) {
                $this->addUsingAlias(EmailAddressTableMap::COL_ID, $id['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(EmailAddressTableMap::COL_ID, $id, $comparison);
    }

    /**
     * Filter the query on the verified column
     *
     * Example usage:
     * <code>
     * $query->filterByVerified(true); // WHERE verified = true
     * $query->filterByVerified('yes'); // WHERE verified = true
     * </code>
     *
     * @param     boolean|string $verified The value to use as filter.
     *              Non-boolean arguments are converted using the following rules:
     *                * 1, '1', 'true',  'on',  and 'yes' are converted to boolean true
     *                * 0, '0', 'false', 'off', and 'no'  are converted to boolean false
     *              Check on string values is case insensitive (so 'FaLsE' is seen as 'false').
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildEmailAddressQuery The current query, for fluid interface
     */
    public function filterByVerified($verified = null, $comparison = null)
    {
        if (is_string($verified)) {
            $verified = in_array(strtolower($verified), array('false', 'off', '-', 'no', 'n', '0', '')) ? false : true;
        }

        return $this->addUsingAlias(EmailAddressTableMap::COL_VERIFIED, $verified, $comparison);
    }

    /**
     * Filter the query on the verification column
     *
     * Example usage:
     * <code>
     * $query->filterByVerification('fooValue');   // WHERE verification = 'fooValue'
     * $query->filterByVerification('%fooValue%'); // WHERE verification LIKE '%fooValue%'
     * </code>
     *
     * @param     string $verification The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildEmailAddressQuery The current query, for fluid interface
     */
    public function filterByVerification($verification = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($verification)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $verification)) {
                $verification = str_replace('*', '%', $verification);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(EmailAddressTableMap::COL_VERIFICATION, $verification, $comparison);
    }

    /**
     * Filter the query on the address column
     *
     * Example usage:
     * <code>
     * $query->filterByAddress('fooValue');   // WHERE address = 'fooValue'
     * $query->filterByAddress('%fooValue%'); // WHERE address LIKE '%fooValue%'
     * </code>
     *
     * @param     string $address The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildEmailAddressQuery The current query, for fluid interface
     */
    public function filterByAddress($address = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($address)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $address)) {
                $address = str_replace('*', '%', $address);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(EmailAddressTableMap::COL_ADDRESS, $address, $comparison);
    }

    /**
     * Filter the query on the owner column
     *
     * Example usage:
     * <code>
     * $query->filterByOwner(1234); // WHERE owner = 1234
     * $query->filterByOwner(array(12, 34)); // WHERE owner IN (12, 34)
     * $query->filterByOwner(array('min' => 12)); // WHERE owner > 12
     * </code>
     *
     * @see       filterByUserRelatedByOwner()
     *
     * @param     mixed $owner The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildEmailAddressQuery The current query, for fluid interface
     */
    public function filterByOwner($owner = null, $comparison = null)
    {
        if (is_array($owner)) {
            $useMinMax = false;
            if (isset($owner['min'])) {
                $this->addUsingAlias(EmailAddressTableMap::COL_OWNER, $owner['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($owner['max'])) {
                $this->addUsingAlias(EmailAddressTableMap::COL_OWNER, $owner['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(EmailAddressTableMap::COL_OWNER, $owner, $comparison);
    }

    /**
     * Filter the query by a related \Eater\Glim\Model\User object
     *
     * @param \Eater\Glim\Model\User|ObjectCollection $user The related object(s) to use as filter
     * @param string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @throws \Propel\Runtime\Exception\PropelException
     *
     * @return ChildEmailAddressQuery The current query, for fluid interface
     */
    public function filterByUserRelatedByOwner($user, $comparison = null)
    {
        if ($user instanceof \Eater\Glim\Model\User) {
            return $this
                ->addUsingAlias(EmailAddressTableMap::COL_OWNER, $user->getId(), $comparison);
        } elseif ($user instanceof ObjectCollection) {
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }

            return $this
                ->addUsingAlias(EmailAddressTableMap::COL_OWNER, $user->toKeyValue('PrimaryKey', 'Id'), $comparison);
        } else {
            throw new PropelException('filterByUserRelatedByOwner() only accepts arguments of type \Eater\Glim\Model\User or Collection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the UserRelatedByOwner relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return $this|ChildEmailAddressQuery The current query, for fluid interface
     */
    public function joinUserRelatedByOwner($relationAlias = null, $joinType = Criteria::LEFT_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('UserRelatedByOwner');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'UserRelatedByOwner');
        }

        return $this;
    }

    /**
     * Use the UserRelatedByOwner relation User object
     *
     * @see useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return \Eater\Glim\Model\UserQuery A secondary query class using the current class as primary query
     */
    public function useUserRelatedByOwnerQuery($relationAlias = null, $joinType = Criteria::LEFT_JOIN)
    {
        return $this
            ->joinUserRelatedByOwner($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'UserRelatedByOwner', '\Eater\Glim\Model\UserQuery');
    }

    /**
     * Filter the query by a related \Eater\Glim\Model\User object
     *
     * @param \Eater\Glim\Model\User|ObjectCollection $user the related object to use as filter
     * @param string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildEmailAddressQuery The current query, for fluid interface
     */
    public function filterByUserRelatedByEmail($user, $comparison = null)
    {
        if ($user instanceof \Eater\Glim\Model\User) {
            return $this
                ->addUsingAlias(EmailAddressTableMap::COL_ID, $user->getEmail(), $comparison);
        } elseif ($user instanceof ObjectCollection) {
            return $this
                ->useUserRelatedByEmailQuery()
                ->filterByPrimaryKeys($user->getPrimaryKeys())
                ->endUse();
        } else {
            throw new PropelException('filterByUserRelatedByEmail() only accepts arguments of type \Eater\Glim\Model\User or Collection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the UserRelatedByEmail relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return $this|ChildEmailAddressQuery The current query, for fluid interface
     */
    public function joinUserRelatedByEmail($relationAlias = null, $joinType = Criteria::LEFT_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('UserRelatedByEmail');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'UserRelatedByEmail');
        }

        return $this;
    }

    /**
     * Use the UserRelatedByEmail relation User object
     *
     * @see useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return \Eater\Glim\Model\UserQuery A secondary query class using the current class as primary query
     */
    public function useUserRelatedByEmailQuery($relationAlias = null, $joinType = Criteria::LEFT_JOIN)
    {
        return $this
            ->joinUserRelatedByEmail($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'UserRelatedByEmail', '\Eater\Glim\Model\UserQuery');
    }

    /**
     * Filter the query by a related \Eater\Glim\Model\EmailMessage object
     *
     * @param \Eater\Glim\Model\EmailMessage|ObjectCollection $emailMessage the related object to use as filter
     * @param string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildEmailAddressQuery The current query, for fluid interface
     */
    public function filterByEmailMessageRelatedByRecipient($emailMessage, $comparison = null)
    {
        if ($emailMessage instanceof \Eater\Glim\Model\EmailMessage) {
            return $this
                ->addUsingAlias(EmailAddressTableMap::COL_ID, $emailMessage->getRecipient(), $comparison);
        } elseif ($emailMessage instanceof ObjectCollection) {
            return $this
                ->useEmailMessageRelatedByRecipientQuery()
                ->filterByPrimaryKeys($emailMessage->getPrimaryKeys())
                ->endUse();
        } else {
            throw new PropelException('filterByEmailMessageRelatedByRecipient() only accepts arguments of type \Eater\Glim\Model\EmailMessage or Collection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the EmailMessageRelatedByRecipient relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return $this|ChildEmailAddressQuery The current query, for fluid interface
     */
    public function joinEmailMessageRelatedByRecipient($relationAlias = null, $joinType = Criteria::LEFT_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('EmailMessageRelatedByRecipient');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'EmailMessageRelatedByRecipient');
        }

        return $this;
    }

    /**
     * Use the EmailMessageRelatedByRecipient relation EmailMessage object
     *
     * @see useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return \Eater\Glim\Model\EmailMessageQuery A secondary query class using the current class as primary query
     */
    public function useEmailMessageRelatedByRecipientQuery($relationAlias = null, $joinType = Criteria::LEFT_JOIN)
    {
        return $this
            ->joinEmailMessageRelatedByRecipient($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'EmailMessageRelatedByRecipient', '\Eater\Glim\Model\EmailMessageQuery');
    }

    /**
     * Filter the query by a related \Eater\Glim\Model\EmailMessage object
     *
     * @param \Eater\Glim\Model\EmailMessage|ObjectCollection $emailMessage the related object to use as filter
     * @param string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return ChildEmailAddressQuery The current query, for fluid interface
     */
    public function filterByEmailMessageRelatedBySender($emailMessage, $comparison = null)
    {
        if ($emailMessage instanceof \Eater\Glim\Model\EmailMessage) {
            return $this
                ->addUsingAlias(EmailAddressTableMap::COL_ID, $emailMessage->getSender(), $comparison);
        } elseif ($emailMessage instanceof ObjectCollection) {
            return $this
                ->useEmailMessageRelatedBySenderQuery()
                ->filterByPrimaryKeys($emailMessage->getPrimaryKeys())
                ->endUse();
        } else {
            throw new PropelException('filterByEmailMessageRelatedBySender() only accepts arguments of type \Eater\Glim\Model\EmailMessage or Collection');
        }
    }

    /**
     * Adds a JOIN clause to the query using the EmailMessageRelatedBySender relation
     *
     * @param     string $relationAlias optional alias for the relation
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return $this|ChildEmailAddressQuery The current query, for fluid interface
     */
    public function joinEmailMessageRelatedBySender($relationAlias = null, $joinType = Criteria::LEFT_JOIN)
    {
        $tableMap = $this->getTableMap();
        $relationMap = $tableMap->getRelation('EmailMessageRelatedBySender');

        // create a ModelJoin object for this join
        $join = new ModelJoin();
        $join->setJoinType($joinType);
        $join->setRelationMap($relationMap, $this->useAliasInSQL ? $this->getModelAlias() : null, $relationAlias);
        if ($previousJoin = $this->getPreviousJoin()) {
            $join->setPreviousJoin($previousJoin);
        }

        // add the ModelJoin to the current object
        if ($relationAlias) {
            $this->addAlias($relationAlias, $relationMap->getRightTable()->getName());
            $this->addJoinObject($join, $relationAlias);
        } else {
            $this->addJoinObject($join, 'EmailMessageRelatedBySender');
        }

        return $this;
    }

    /**
     * Use the EmailMessageRelatedBySender relation EmailMessage object
     *
     * @see useQuery()
     *
     * @param     string $relationAlias optional alias for the relation,
     *                                   to be used as main alias in the secondary query
     * @param     string $joinType Accepted values are null, 'left join', 'right join', 'inner join'
     *
     * @return \Eater\Glim\Model\EmailMessageQuery A secondary query class using the current class as primary query
     */
    public function useEmailMessageRelatedBySenderQuery($relationAlias = null, $joinType = Criteria::LEFT_JOIN)
    {
        return $this
            ->joinEmailMessageRelatedBySender($relationAlias, $joinType)
            ->useQuery($relationAlias ? $relationAlias : 'EmailMessageRelatedBySender', '\Eater\Glim\Model\EmailMessageQuery');
    }

    /**
     * Exclude object from result
     *
     * @param   ChildEmailAddress $emailAddress Object to remove from the list of results
     *
     * @return $this|ChildEmailAddressQuery The current query, for fluid interface
     */
    public function prune($emailAddress = null)
    {
        if ($emailAddress) {
            $this->addUsingAlias(EmailAddressTableMap::COL_ID, $emailAddress->getId(), Criteria::NOT_EQUAL);
        }

        return $this;
    }

    /**
     * Deletes all rows from the email_address table.
     *
     * @param ConnectionInterface $con the connection to use
     * @return int The number of affected rows (if supported by underlying database driver).
     */
    public function doDeleteAll(ConnectionInterface $con = null)
    {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getWriteConnection(EmailAddressTableMap::DATABASE_NAME);
        }

        // use transaction because $criteria could contain info
        // for more than one table or we could emulating ON DELETE CASCADE, etc.
        return $con->transaction(function () use ($con) {
            $affectedRows = 0; // initialize var to track total num of affected rows
            $affectedRows += parent::doDeleteAll($con);
            // Because this db requires some delete cascade/set null emulation, we have to
            // clear the cached instance *after* the emulation has happened (since
            // instances get re-added by the select statement contained therein).
            EmailAddressTableMap::clearInstancePool();
            EmailAddressTableMap::clearRelatedInstancePool();

            return $affectedRows;
        });
    }

    /**
     * Performs a DELETE on the database based on the current ModelCriteria
     *
     * @param ConnectionInterface $con the connection to use
     * @return int             The number of affected rows (if supported by underlying database driver).  This includes CASCADE-related rows
     *                         if supported by native driver or if emulated using Propel.
     * @throws PropelException Any exceptions caught during processing will be
     *                         rethrown wrapped into a PropelException.
     */
    public function delete(ConnectionInterface $con = null)
    {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getWriteConnection(EmailAddressTableMap::DATABASE_NAME);
        }

        $criteria = $this;

        // Set the correct dbName
        $criteria->setDbName(EmailAddressTableMap::DATABASE_NAME);

        // use transaction because $criteria could contain info
        // for more than one table or we could emulating ON DELETE CASCADE, etc.
        return $con->transaction(function () use ($con, $criteria) {
            $affectedRows = 0; // initialize var to track total num of affected rows

            EmailAddressTableMap::removeInstanceFromPool($criteria);

            $affectedRows += ModelCriteria::delete($con);
            EmailAddressTableMap::clearRelatedInstancePool();

            return $affectedRows;
        });
    }

} // EmailAddressQuery
